part of redstone.rethinkdb;

app.RedstonePlugin rethinkPlugin(RethinkDbManager db, {String pattern: r'/.*'}) {

  return (app.Manager manager) {

    if (db == null)
      return;

    manager.addInterceptor(new app.Interceptor(pattern), "database connection manager", (injector, app.Request request) async {

      RethinkConnection conn = await db.getConnection();
      app.request.attributes["dbConn"] = conn.conn;

      await app.chain.next();

      db.closeConnection(conn, error: app.chain.error);
    });
  };
}